import { web3 } from "hardhat";
import History from "./interface/history";
import contracts from "../config/contracts";
import logger from "../utils/logger";
import v3_routers from "../config/v3_routers";
import {BigNumber} from "ethers";
import {replaceAll} from "hardhat/internal/util/strings";

async function handlePosition(router: String, factory: String) {
  try {
    // 拉取当前pull状态信息
    const pullState = await History.findByHashOrBlockOrDataVague('UNIV3DEX', factory, '', 0, 200)
    let nowPosition = 0

    // 没有状态信息的情况
    if (pullState.data.length == 0) {
      const appendRst = await History.appendOrUpdate('UNIV3DEX', factory, {"now": nowPosition})
      logger.debug(appendRst)
    } else {
      nowPosition = pullState.data[0].dataObj.now
    }

    return nowPosition
  } catch (e) {
    logger.error(`Pull state error, router: ${router}, factory: ${factory}`)
    logger.error(e)
  }

  return 0
}

async function handleAFactory(router: String, factory: String, position: number, v3_tool: any, v3PositionManager: any) {
  let errorCount = 0

  while (true) {
    try {
      const positionInfo = await v3PositionManager.methods.positions(position).call()
      const info = await v3_tool.methods.getMoreInfo(positionInfo.token0, positionInfo.token1, positionInfo.fee).call()

      const symbol0 = info.symbol0.replace(/[^A-Za-z0-9 ]+/g, '').substring(0, 10)
      const symbol1 = info.symbol1.replace(/[^A-Za-z0-9 ]+/g, '').substring(0, 10)
      const name = `${router.slice(2, 4) + router.slice(-2)}_${symbol0}_${symbol1}`
      const sum2 = replaceAll(BigNumber.from(positionInfo.token0).add(BigNumber.from(positionInfo.token1))._hex, '0x0', '0x')

      const data = {
        LP: info.lp,
        decimals0: info.decimals0,
        decimals1: info.decimals1,
        factory: factory,
        feei: positionInfo.fee,
        id: position,
        name: name,
        r0: info.r0,
        r1: info.r1,
        router: router,
        sum2: sum2,
        symbol0: symbol0,
        symbol1: symbol1,
        token0: positionInfo.token0,
        token1: positionInfo.token1
      }

      const insertRst = await History.appendOrUpdate('0', info.lp, data)
      logger.debug(insertRst.msg, `, hash: ${info.lp}, ${position}`)

      // 每十次更新一次position
      if (position % 50 == 0) {
        await History.appendOrUpdate('UNIV3DEX', factory, {"now": position})
        logger.debug(`Position updated: ${position}`)
      }

      errorCount = 0
    } catch (e) {
      logger.error(JSON.stringify(e))
      errorCount++
    }

    position++
    if (errorCount >= 5) {
      position = position - 5
      break;
    }
  }
}

async function main() {
  const fromZero: boolean = true

  logger.debug('Pull v3 start.')

  const v3_router_abi = require('../abi/UNIV3_ROUTER_ABI.json')
  const positionManagerAbi = require('../abi/UNIV3_POSITION_MANAGER_ABI.json')
  const v3_tool_abi = require('../artifacts/contracts/V3Tool.sol/V3Tool.json').abi

  // 初始化 v3工具箱
  const v3_tool = new web3.eth.Contract(v3_tool_abi, contracts.TOOLS_V3)
  // 初始化PositionManager
  const v3PositionManager = new web3.eth.Contract(positionManagerAbi, contracts.UNIV3_POSITION)

  for (let router_index = 0; router_index < v3_routers.length; router_index++) {
    const v3_router_address = v3_routers[router_index]

    try {
      logger.debug(`Router address: ${v3_router_address}`)

      // 获取工厂地址
      const v3_router = new web3.eth.Contract(v3_router_abi, v3_router_address)
      const v3_factory_address = await v3_router.methods.factory().call()
      // 获取当前pull状态
      const position = fromZero ? 1 : await handlePosition(v3_router_address, v3_factory_address)

      logger.debug(`factory: ${v3_factory_address}, ${position}.`)
      await handleAFactory(v3_router_address, v3_factory_address, position, v3_tool, v3PositionManager)
    } catch (e) {
      logger.error(`New contract error, router: ${v3_router_address}`)
      logger.error(e)
    }
  }
}

main().catch((error) => {
  console.error(error);
  process.exitCode = 1;
})
